#import <Foundation/Foundation.h>

void usage(){
	printf("pathconvert returns a modified osx path string based on the following switches.\npathconvert -u pathurl\nTakes a pathurl of the form file://localhost/Volumes/Storage/Users/Dale/test used by Final Cut XML and converts it to an AbsoluteURI that Adobe After Effects will be such that the pathurl above becomes ~/test.\npathconvert -f fullpath\nTakes a fullpath of the form /Volumes/MyHD/Users/Dale/Test and returns a short cut tilde path when appropriate. The string above would become ~/Test.\npathconvert -t abbreviatedPath\nTakes a short cut path of the form ~/Test and returns a full path when appropriate. The string above would become /Volumes/MyHD/Users/Dale/Test.\n");
}

void tildePath(const char * commandPath){

	   NSString *absolutePath;
   
	   if(commandPath){
			absolutePath =  [[NSString alloc]initWithCString: commandPath];
	   }else{
			usage();
	   }
	   
	   NSString *tildePath = [absolutePath stringByAbbreviatingWithTildeInPath];
	   printf ("%s\n", [tildePath cString]);
	   
	   
	   [absolutePath release];
		
}

void expandedPath(const char * commandPath){

	   NSString *tildePath;
   
	   if(commandPath){
			tildePath =  [[NSString alloc]initWithCString: commandPath];
	   }else{
			usage();
	   }
	   
	   NSString *absolutePath = [tildePath stringByExpandingTildeInPath];
	   printf ("%s\n", [absolutePath cString]);
	   
	   
	   [tildePath release];
		
}
void urlDecode(const char * commandPath){

	   NSString *path = [[NSString alloc]initWithCString: commandPath];
	  // NSLog(@"%@", path);
	   
	   NSURL *fileURL;
       NSString *pathString;
	   
	   if(commandPath){
			fileURL = [NSURL URLWithString: path];
			pathString = [fileURL path];
			
	   }else{
			usage();
	   }
	   
	   NSString *tildePath = [pathString stringByAbbreviatingWithTildeInPath];
	   printf ("%s\n", [tildePath cString]);	   
	   
	   [path release];
		
}

int main (int argc, const char * argv[]) {
	if(argc == 3){
		
		NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
        char arg = argv[1][1];
		
		switch(arg){
			case 'f':
				tildePath(argv[2]);
				break;
			case 't':
				expandedPath(argv[2]);
				break;
			case 'u':
				urlDecode(argv[2]);
				break;
		}
		
   [pool release];
   
   }else{
		usage();
   }
    return 0;
}
